Ruby - Bug #19793

Segmentation fault when requiring files after defining Object#method_missing
08/01/2023 04:08 PM - sczimmer (Scott Zimmermann)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 3.2.2 (2023-03-30 revision Backport: 3.0: DONTNEED, 3.1: DONTNEED, 3.2:
€51014f9c0) [aarch64-linux] DONE

Description

| was doing ruby koans to learn ruby and | got a segmentation fault when it gets to the part where it uses Symbol.all_symbols. |
realized it happens with any large Array, but | cannot reproduce in a small test script, just when it runs the whole ruby koans. So the
minimal way to reproduce | have is:

download rubykoans: https:/github.com/edgecase/ruby_koans/blob/master/download/rubykoans.zip?raw=true

unzip rubykoans.zip

cd koans

# fix deprecated method call for ruby 3.2

ruby -i -pe 'sub "File.exists", "File.exist"' neo.rb

Edit about_asserts.rb, adding these two statements to make a big array to the first koan:

def test_assert_truth

array = []

99130.times { array << "a string"}

assert false # This should be true
end

run ruby path_to_enlightenment.rb and get a backirace like the attached backtrace.txt

I've tried this on two servers, ubuntu aarch64 and debian x86_64. On both it crashes with ruby 3.2.2 and works fine with ruby 3.1. On
both | installed ruby built from source with RVM. On the server with more ram | had to increase the number more (above it's 99130)
to get it to crash.

Associated revisions

Revision 1d096c1e53581ed9fe94694c9760babd1e12e580 - 08/02/2023 01:08 PM - peterzhu2118 (Peter Zhu)

Fix crash in NoMethodError for dummy frames
[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseq to the created NoMethodError.

The following script crashes:
GC.stress = true
class Object

public :method_missing

end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:
frame #0: 0x00000001000fa8b8 miniruby' RVALUE_MARKED (0bj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000fb440 miniruby RVALUE_BLACK_P (0bj=4308637824) at gc.c:1763:12
frame #2: 0x00000001000facdc miniruby gc_writebarrier incremental (a=4308637824, b=4308332208, objspace=0x00000
https://github.com/edgecase/ruby_koans/blob/master/download/rubykoans.zip?raw=true

0010180b000) at gc.c:8822:9

frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../iseqg.c"
, line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100d09888, b=4308332208, filena
me="../iseq.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby iseqw_new (1isegq=0x0000000100d09880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (isegq=0x0000000100d409880) at iseg.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_init_attr (exc=4309777920, recv=4304780496, method=827660) at er
ror.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, method=8
27660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660, ar
gs=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=4304
780496, argc=1l, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing(ec=0x0000000100b06£f40, argc=1l, argv=0x000000016fdf
ab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15

frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496) at v
m_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_kw(ec=0x0000000100b06£40, recv=4304780496, 1d=2865, argc=1,

argv=0x000000016fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call_method_entry (ec=0x0000000100b06£40, defined_class=4304927952, obj=

4304780496, id=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2720:

20

frame #25: 0x00000001003c440c miniruby check_funcall_exec(v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby’ check_funcall_exec at vm_eval.c:587), data
1=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792, args="P{4") at eval.c:
919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), datal

=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall_missing(ec=0x0000000100b06£f40, klass=4304923536, recv=430

4780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall default_kw(recv=4304780496, mid=3233, argc=0, argv=0x0
000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x000000000000
0000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, raise

=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4ad4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String", m

ethod=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11

frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4) at
io.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016fdfb450, i0=4308334032) at i

0.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_cfunc_ml (recv=4308334032, argc=1, argv=0x000000016fdfb
450, func=(miniruby rb_io_set_encoding at i0.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby' rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

Revision 1d096c1e53581ed9fe94694c9760babd1e12e580 - 08/02/2023 01:08 PM - peterzhu2118 (Peter Zhu)

Fix crash in NoMethodError for dummy frames
[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseq to the created NoMethodError.

The following script crashes:
GC.stress = true
class Object

public :method_missing
end
File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:

frame #0: 0x00000001000fa8b8 miniruby RVALUE_MARKED (0bj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000fb440 miniruby RVALUE_BLACK_P (obj=4308637824) at gc.c:1763:12

frame #2: 0x00000001000facdc miniruby gc_writebarrier_incremental (a=4308637824, b=4308332208, objspace=0x00000
0010180b000) at gc.c:8822:9

frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../iseqg.c"
, line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100409888, b=4308332208, filena
me="../iseqg.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby iseqw_new (iseg=0x0000000100d09880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (iseg=0x0000000100d09880) at iseq.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_init_attr (exc=4309777920, recv=4304780496, method=827660) at er
ror.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, method=8
27660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660, ar
gs=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=4304
780496, argc=1l, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing (ec=0x0000000100b06£40, argc=1, argv=0x000000016fdf
ab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15

frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1l, argv=0x000000016fdfab00, obj=4304780496) at v
m_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_kw (ec=0x0000000100b06£40, recv=4304780496, i1d=2865, argc=1,

argv=0x000000016fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call _method_entry (ec=0x0000000100b06£f40, defined_class=4304927952, obij=
4304780496, 1d=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2720:
20

frame #25: 0x00000001003c440c miniruby check_funcall exec (v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby’ check_funcall_exec at vm_eval.c:587), data
1=6171896792, r_proc=(miniruby check_funcall_ failed at vm_eval.c:596), data2=6171896792, args="P4") at eval.c:
919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), datal

=6171896792, r_proc=(miniruby check_funcall_ failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall missing(ec=0x0000000100b06£f40, klass=4304923536, recv=430
4780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv=0x0
000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby' rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x000000000000
0000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, raise

=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4ad4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String", m

ethod=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11

frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4) at
i0.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016£fdfb450, 10=4308334032) at i

0.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_ cfunc_ml (recv=4308334032, argc=1l, argv=0x000000016fdfb
450, func=(miniruby rb_io_set_encoding at i10.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

Revision 1d096c1e - 08/02/2023 01:08 PM - peterzhu2118 (Peter Zhu)

Fix crash in NoMethodError for dummy frames
[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseq to the created NoMethodError.
The following script crashes:
GC.stress = true

class Object
public :method_missing
end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:

frame #0: 0x00000001000fa8b8 miniruby RVALUE_MARKED (0bj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000£fb440 miniruby RVALUE_BLACK_P (obj=4308637824) at gc.c:1763:12

frame #2: 0x00000001000facdc miniruby gc_writebarrier_incremental (a=4308637824, b=4308332208, objspace=0x00000
0010180b000) at gc.c:8822:9

frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../iseqg.c"
, line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100409888, b=4308332208, filena
me="../iseqg.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby iseqw_new (iseq=0x0000000100d09880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (iseg=0x0000000100d09880) at iseq.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_init_attr (exc=4309777920, recv=4304780496, method=827660) at er
ror.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, method=8
27660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660, ar
gs=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=4304
780496, argc=1l, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing(ec=0x0000000100b06£40, argc=1, argv=0x000000016fdf
ab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15

frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496) at v
m_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_ kw(ec=0x0000000100b06£40, recv=4304780496, id=2865, argc=1,
argv=0x000000016£fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call_method_entry (ec=0x0000000100b06£f40, defined_class=4304927952, obj=
4304780496, 1d=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2720:
20

frame #25: 0x00000001003c440c miniruby check_funcall_exec(v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), data
1=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792, args="PQ4") at eval.c:
919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), datal
=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall_missing(ec=0x0000000100b06f40, klass=4304923536, recv=430
4780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv=0x0
000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x000000000000
0000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, raise

=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4ad4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String", m

ethod=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11

frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4) at
io.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016fdfb450, 1i0=4308334032) at i

0.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_cfunc_ml (recv=4308334032, argc=1, argv=0x000000016fdfb
450, func=(miniruby rb_io_set_encoding at 10.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

Revision 3c9¢b7031154b8666d600b0055ba868e18805dc8 - 08/12/2023 04:48 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 1d096c1e53581ed9fe94694c9760babd1e12e580: [Backport #19793]

Fix crash in NoMethodError for dummy frames
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseg to the created NoMethodError.

The following script crashes:

GC.stress = true

class Object
public :method_missing
end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:

frame #0: 0x00000001000fa8b8 miniruby RVALUE_MARKED (obj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000fb440 miniruby RVALUE_BLACK_P (obj=4308637824) at gc.c:1763:12

frame #2: 0x00000001000facdc miniruby gc_writebarrier_incremental (a=4308637824, b=4308332208, objspace=0x0
00000010180b000) at gc.c:8822:9

frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../ise
g.c", line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100d409888, b=4308332208, fi
lename="../iseq.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby iseqw_new (iseg=0x0000000100d09880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (iseg=0x0000000100d09880) at iseqg.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_init_attr (exc=4309777920, recv=4304780496, method=827660) a
t error.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, meth
0d=827660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660
, args=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=
4304780496, argc=1l, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing(ec=0x0000000100b06£f40, argc=1, argv=0x00000001
6fdfab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15

frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496)
at vm_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_kw (ec=0x0000000100b06£40, recv=4304780496, id=2865, argc
=1, argv=0x000000016fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call_method_entry (ec=0x0000000100b06£f40, defined_class=4304927952,
0bj=4304780496, 1d=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2
720:20

frame #25: 0x00000001003c440c miniruby check_funcall exec (v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587),
datal=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792, args="P4") at eva
1.c:919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), d
atal=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall missing(ec=0x0000000100b06£f40, klass=4304923536, recv
=4304780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv
=0x0000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x00000000
00000000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, r
aise=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4ad4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String
", method=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11
frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4
) at io0.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016£fdfb450, 10=4308334032)
at 10.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_cfunc_ml (recv=4308334032, argc=1l, argv=0x000000016
£dfb450, func=(miniruby rb_io_set_encoding at i0.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

error.c | 4 +++-
test/ruby/test_require.rb | 15 +++++++++++++++
2 files changed, 18 insertions(+), 1 deletion(-)

Revision 3¢9cb7031154b8666d600b0055ba868e18805dc8 - 08/12/2023 04:48 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 1d096c1e53581ed9fe94694c9760babd1e12e580: [Backport #19793]

Fix crash in NoMethodError for dummy frames
MIME-Version: 1.0

Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseq to the created NoMethodError.

The following script crashes:

GC.stress = true

class Object
public :method_missing
end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:

frame #0: 0x00000001000fa8b8 miniruby RVALUE_MARKED (0bj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000£fb440 miniruby RVALUE_BLACK_P (obj=4308637824) at gc.c:1763:12

frame #2: 0x00000001000facdc miniruby gc_writebarrier_incremental (a=4308637824, b=4308332208, objspace=0x0
00000010180b000) at gc.c:8822:9

frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../ise
g.c", line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100409888, b=4308332208, fi
lename="../iseq.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby iseqw_new (iseq=0x0000000100d09880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (iseg=0x0000000100d09880) at iseq.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_init_attr (exc=4309777920, recv=4304780496, method=827660) a
t error.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, meth
0d=827660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660
, args=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=
4304780496, argc=1l, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing(ec=0x0000000100b06£40, argc=1, argv=0x00000001
6fdfab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15

frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496)
at vm_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_kw (ec=0x0000000100b06£40, recv=4304780496, id=2865, argc
=1, argv=0x000000016fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call_method_entry (ec=0x0000000100b06£f40, defined_class=4304927952,
0bj=4304780496, 1d=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2
720:20

frame #25: 0x00000001003c440c miniruby check_funcall exec (v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587),
datal=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792, args="P4") at eva
1.c:919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), d
atal=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall missing(ec=0x0000000100b06£f40, klass=4304923536, recv
=4304780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv
=0x0000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby' rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x00000000
00000000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, r
aise=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4ad4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String
", method=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11

frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4
) at io0.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016£fdfb450, 10=4308334032)
at 10.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_cfunc_ml (recv=4308334032, argc=1l, argv=0x000000016
£dfb450, func=(miniruby rb_io_set_encoding at i0.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

error.c | 4 +++-
test/ruby/test_require.rb | 15 +++++++++++++++
2 files changed, 18 insertions(+), 1 deletion(-)

Revision 3¢9cb703 - 08/12/2023 04:48 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 1d096c1e53581ed9fe94694c9760babd1e12e580: [Backport #19793]

Fix crash in NoMethodError for dummy frames
MIME-Version: 1.0

Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseq to the created NoMethodError.

The following script crashes:

GC.stress = true

class Object
public :method_missing
end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:

frame #0: 0x00000001000fa8b8 miniruby RVALUE_MARKED (0bj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000£fb440 miniruby RVALUE_BLACK_P (obj=4308637824) at gc.c:1763:12

frame #2: 0x00000001000facdc miniruby gc_writebarrier_incremental (a=4308637824, b=4308332208, objspace=0x0
00000010180b000) at gc.c:8822:9
frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../ise
g.c", line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100d409888, b=4308332208, fi
lename="../iseq.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby iseqw_new (iseg=0x0000000100d09880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (isegq=0x0000000100d09880) at iseqg.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_init_attr (exc=4309777920, recv=4304780496, method=827660) a
t error.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, meth
0d=827660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660
, args=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=
4304780496, argc=1l, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing(ec=0x0000000100b06£f40, argc=1, argv=0x00000001
6fdfab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15

frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496)
at vm_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_kw (ec=0x0000000100b06£40, recv=4304780496, id=2865, argc
=1, argv=0x000000016fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call_method_entry (ec=0x0000000100b06£f40, defined_class=4304927952,
0bj=4304780496, 1d=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2
720:20

frame #25: 0x00000001003c440c miniruby check_funcall exec (v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587),
datal=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792, args="P4") at eva
1.c:919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), d
atal=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall missing(ec=0x0000000100b06£f40, klass=4304923536, recv
=4304780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv
=0x0000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x00000000
00000000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, r
aise=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4ad4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String
", method=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11

frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4
) at io0.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016£fdfb450, 10=4308334032)
at 10.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_cfunc_ml (recv=4308334032, argc=1l, argv=0x000000016
£fdfb450, func=(miniruby rb_io_set_encoding at i0.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

error.c | 4 +++-
test/ruby/test_require.rb | 15 +++++++++++++++
2 files changed, 18 insertions(+), 1 deletion(-)

History

#1 - 08/01/2023 06:32 PM - byroot (Jean Boussier)

So instead of 99130.times { array << "a string"} you can just add GC.start and it will also crash.
| also tested it's still failing on master. I'll see if this can be reduced.

#2 - 08/01/2023 09:03 PM - peterzhu2118 (Peter Zhu)

Thank you for reporting this bug.

The following script is a minimal reproduction:

GC.stress = true

class Object
public :method_missing
end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

| have a fix in this PR: https://github.com/ruby/ruby/pull/8155

#3 - 08/01/2023 09:03 PM - peterzhu2118 (Peter Zhu)
- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: DONTNEED, 3.1: DONTNEED, 3.2: REQUIRED

#4 - 08/01/2023 09:59 PM - byroot (Jean Boussier)

- Subject changed from Segmentation fault with large arrays to Segmentation when requiring files after defining Object#method_missing

#5 - 08/01/2023 11:22 PM - sczimmer (Scott Zimmermann)

thanks, you all are fast :)
#6 - 08/02/2023 06:43 AM - byroot (Jean Boussier)
- Subject changed from Segmentation when requiring files after defining Object#method_missing to Segmentation fault when requiring files after

defining Object#method_missing

#7 - 08/02/2023 01:08 PM - peterzhu2118 (Peter Zhu)
- Status changed from Open to Closed

Applied in changeset git[1d096c1e53581ed9fe94694c9760babd1e12e580.

Fix crash in NoMethodError for dummy frames
[Bug #19793]

Dummy frames are created at the top level when requiring another file.
While requiring a file, it will try to convert using encodings. Some of
these encodings will not respond to to_str. If method_missing is
redefined on Object, then it will call method_missing and attempt raise
an error. However, the iseq is invalid as it's a dummy frame so it will
write an invalid iseq to the created NoMethodError.

The following script crashes:
GC.stress = true

class Object
public :method_missing
end

File.write("/tmp/empty.rb", "")
require "/tmp/empty.rb"

With the following backtrace:

frame #0: 0x00000001000fa8b8 miniruby RVALUE_MARKED (0cbj=4308637824) at gc.c:1638:12

frame #1: 0x00000001000fb440 miniruby RVALUE_BLACK_P (obj=4308637824) at gc.c:1763:12

frame #2: 0x00000001000facdc miniruby gc_writebarrier_incremental (a=4308637824, b=4308332208, objspace=0x00000
0010180b000) at gc.c:8822:9

frame #3: 0x00000001000faad8 miniruby rb_gc_writebarrier (a=4308637824, b=4308332208) at gc.c:8864:17

frame #4: 0x000000010016aff0 miniruby rb_obj_written (a=4308637824, oldv=36, b=4308332208, filename="../iseq.c"
, 1line=1279) at gc.h:804:9

frame #5: 0x0000000100162a60 miniruby rb_obj_write (a=4308637824, slot=0x0000000100d09888, b=4308332208, filena
me="../iseq.c", line=1279) at gc.h:837:5

frame #6: 0x0000000100165b0c miniruby  iseqw_new (iseg=0x0000000100d409880) at iseq.c:1279:9

frame #7: 0x0000000100165a64 miniruby rb_iseqw_new (isegq=0x0000000100d409880) at iseqg.c:1289:12

frame #8: 0x00000001000d8324 miniruby name_err_ init_attr (exc=4309777920, recv=4304780496, method=827660) at er
ror.c:1830:35

frame #9: 0x00000001000d1b80 miniruby name_err_init (exc=4309777920, mesg=4308332496, recv=4304780496, method=8
27660) at error.c:1869:12

frame #10: 0x00000001000d1bd4 miniruby rb_nomethod_err_new (mesg=4308332496, recv=4304780496, method=827660, ar
gs=4308332448, priv=0) at error.c:1957:5

frame #11: 0x000000010039049c miniruby rb_make_no_method_exception (exc=4304914512, format=4308332496, obj=4304
780496, argc=1, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16

frame #12: 0x00000001003b3274 miniruby raise_method_missing(ec=0x0000000100b06£40, argc=1, argv=0x000000016fdf
ab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15
frame #13: 0x00000001003945d4 miniruby rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496) at v
m_eval.c:944:5

frame #23: 0x000000010038f5e4 miniruby rb_vm_call_ kw(ec=0x0000000100b06£40, recv=4304780496, id=2865, argc=1,

argv=0x000000016£fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12

frame #24: 0x00000001003cl8e4 miniruby call_method_entry (ec=0x0000000100b06£f40, defined_class=4304927952, obj=

4304780496, 1d=2865, cme=0x0000000100cbfcf0, argc=1l, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2720:

20

frame #25: 0x00000001003c440c miniruby check_funcall_exec(v=6171896792) at vm_eval.c:589:12

frame #26: 0x00000001000dec00 miniruby rb_vrescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), data
1=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792, args="PQ4") at eval.c:
919:18

frame #27: 0x00000001000deab0 miniruby rb_rescue2 (b_proc=(miniruby check_funcall_exec at vm_eval.c:587), datal

=6171896792, r_proc=(miniruby check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17

frame #28: 0x000000010039008c miniruby check_funcall_missing(ec=0x0000000100b06f40, klass=4304923536, recv=430

4780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15

frame #29: 0x000000010038fa60 miniruby rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv=0x0
000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21

frame #30: 0x000000010038fb04 miniruby rb_check_funcall (recv=4304780496, mid=3233, argc=0, argv=0x000000000000
0000) at vm_eval.c:685:12

frame #31: 0x00000001001c469c miniruby convert_type_with_id(val=4304780496, tname="String", method=3233, raise

=0, index=-1) at object.c:3061:15

frame #32: 0x00000001001c4a4d4c miniruby rb_check_convert_type_with_id(val=4304780496, type=5, tname="String", m

ethod=3233) at object.c:3153:9

frame #33: 0x00000001002d59f8 miniruby rb_check_string_type (str=4304780496) at string.c:2571:11

frame #34: 0x000000010014b7b0 miniruby io_encoding_set (fptr=0x0000000100d09cal, v1=4304780496, v2=4, opt=4) at
io.c:11655:19

frame #35: 0x0000000100139a58 miniruby rb_io_set_encoding(argc=1, argv=0x000000016fdfb450, 1i0=4308334032) at i

0.c:13497:5

frame #36: 0x00000001003c0004 miniruby ractor_safe_call_cfunc_ml (recv=4308334032, argc=1, argv=0x000000016fdfb
450, func=(miniruby rb_io_set_encoding at i10.c:13487)) at vm_insnhelper.c:3271:12

frame #43: 0x0000000100390b08 miniruby rb_funcall (recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
frame #44: 0x00000001002a43d8 miniruby load_file_internal (argp_v=6171899936) at ruby.c:2500:5

#8 - 08/12/2023 04:48 AM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 3.0: DONTNEED, 3.1: DONTNEED, 3.2: REQUIRED to 3.0: DONTNEED, 3.1: DONE, 3.2: REQUIRED

#9 - 08/12/2023 04:49 AM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 3.0: DONTNEED, 3.1: DONE, 3.2: REQUIRED to 3.0: DONTNEED, 3.1: DONTNEED, 3.2: DONE

ruby_3_2 3c9cb7031154b8666d600b0055ba868e18805dc8 merged revision(s) 1d096c1e53581ed9fe94694c9760babd1e12e580.
